import javax.naming.InitialContext;
import javax.naming.Context;
import javax.rmi.PortableRemoteObject;
import javax.ejb.*;
import java.rmi.RemoteException;
import javax.naming.NamingException;
import hello.*;
import java.util.Properties;
public class HelloEJBClient {
	public static void main(String [] args) {
		try {
			Properties prop = new Properties();
			prop.put("org.omg.CORBA.ORBInitialHost", args[0]);
			InitialContext ctx = new InitialContext(prop);	
			Object obj = ctx.lookup("HelloSessionEJB");
			HelloHome home = (HelloHome)PortableRemoteObject.narrow(obj, HelloHome.class);
			Hello hello = home.create();
			String msg = "";
			if(args.length == 2) 
				msg = hello.sayHello(args[1]);
			else 
				msg = hello.sayHello("Nobody");
			System.out.println(msg);
			hello.remove();
		} catch(NamingException e) {
			System.err.println("Couldn't create proper initial context");
			e.printStackTrace();
		} catch(RemoteException e) {
			System.err.println("Exception occurred during communication ");
			e.printStackTrace();		
		} catch(CreateException e) {
			System.err.println("Couldn't create HelloEJB");
			e.printStackTrace();
		} catch(RemoveException e) {
			e.printStackTrace();
		}
	}
}
